var __SP2013Agent = {};

//SPS2013
var __alreadyinitiated = false;
var __alreadyloaded = false;

function __initEnvironmentAgent() {
    if (__alreadyinitiated) return;
    __alreadyinitiated = true;
}

function __initSP2013Agent() {
    if (__alreadyloaded) return;
    __alreadyloaded = true;

    if (__Page.readyState != "error") {
        // support additional data to view events in param3
        if (element.Param3ElementName) {
            __aeLogger.trace("Param3ElementName is on");
            __Page.param3 = GetParam3ElementValue();
            __aeLogger.trace("__Page.param3: " + __Page.param3);
        }

        // set agent handler
        __Page.agent = "SP2013Agent";

        // handle exceptions (TOCHECK)
        __Page.customShouldContinue = __SP2013ShouldContinue;

        // populate Agent Object Model
        __Page.customInit = __SP2013CreateAOM;

        // set supported events by this agent
        __Page.events = { Visit: true, Leave: true, Search: true, SearchResultItem: true, SearchResultClick: true };

        // overwrite the event detection
        __EventHandler.New = __SP2013EventNew;

        // catch customready if special actions are needed based on custom values
        __Page.attachEvent("customready", __SP2013CreateCustom);

        __Page.init();

        if (__Page.readyState == "ready") __Page.sendEvent(__SP2013NewVisit(), false, false);
    } else {
        window.status = "Error loading SP2013Agent: " + __Page.errorDescription;
        if (typeof (__Status) != "undefined") __Status.print("Error loading SP2013Agent: " + __Page.errorDescription);
        else __Status = { output: new Array({ o: "Error loading SP2013Agent: " + __Page.errorDescription }) };
    }
}

function __SP2013EventNew(e) {
    __aeLogger.trace("__SP2013EventNew");
    var event = new __Event(e);
    __aeLogger.trace("__SP2013EventNew return: " + (event != null ? event.ToString() : "null"));
    return event;
}

function __SP2013NewVisit() {
    __aeLogger.trace("__SP2013NewVisit");
    var event = __EventHandler.NewVisit();
    __aeLogger.trace("__SP2013NewVisit return: " + (event != null ? event.ToString() : "null"));
    return event;
}

function __SP2013ShouldContinue() {
    return "ready";
}

function getElementsByClassName(classname, node) {
    d = node || document;
    if (typeof (document.getElementsByClassName) != "undefined") return d.getElementsByClassName(classname);
    else if (typeof (jQuery) != "undefined") return jQuery(d).find("." + classname);
    else if (typeof (document.querySelectorAll) != "undefined") return d.querySelectorAll("." + classname);
    else {
        node = node || document.body;
        var a = [];
        var re = new RegExp('(^| )' + classname + '( |$)');
        var els = node.getElementsByTagName("*");
        for (var i = 0, j = els.length; i < j; i++) if (re.test(els[i].className)) a.push(els[i]);
        return a;
    }
}
function isSearchPage() {
    return getElementsByClassName("ms-srch-siteSearchResults").length > 0 || getElementsByClassName("ms-srch-result").length > 0;
}

function bindevent(obj, name, callback) {
    if (typeof obj != 'undefined' && obj != null)
        if (obj.attachEvent) {
            obj.attachEvent("on" + name, callback);
        }
        else {
            obj.addEventListener(name, callback, false);
        }
}

var waitforsearchinterval = null;
var cancelwaitforsearchinterval = null;
var waitforsearchboxgrace = 1000;

function cancelWaitForSearch() {
    window.clearInterval(waitforsearchboxgrace);
    __aeLogger.trace("Waiting for search box takes too long...", "sp2013");
}

function handlePaging(e) {
	// Wait for results to load and do some magic.
	document.getElementById("Result").innerHTML = "";
	waitForSearch();
	waitForSearchResults();
}
function handlesearchinput(e) {
    e = event || e;
    if (Srch.U.isEnterKey(String.fromCharCode(e.keyCode)))
		handlePaging();
}
function waitForSearch() {
	if (typeof getElementsByClassName("ms-srch-Paging")[0] == "undefined")
	{
		setTimeout(waitForSearch, 100);
		return;
	}

	// Bind dynamic collection function to the paging links
	// Milen NOTE: maybe it's not needed to bind events to every link - just bind it to the container.
	// This will save system resources.
	var paginglinks = [];

	if (document.getElementById("Paging")) paginglinks = document.getElementById("Paging").getElementsByTagName("a");
	for (var i = 0; i < paginglinks.length; i++) {
		if (paginglinks[i].href != "") bindevent(paginglinks[i], "click", handlePaging);
	}

	// Bind paging clicks listener - not working for some reason, maybe event propagation is turned off
	//bindevent(getElementsByClassName("ms-srch-Paging")[0], "click", handlePaging);
}
var lastresults = null;

function waitForSearchResults() {
    if (typeof getElementsByClassName("ms-srch-result-groups")[0] == "undefined") {
		setTimeout(waitForSearchResults, 100);

		return;
	}

        var searchResults;
        if (getElementsByClassName("ms-srch-siteSearchResults").length > 0 && getElementsByClassName("ms-srch-item").length > 0)
		searchResults = getElementsByClassName("ms-srch-item")
        else
            searchResults = getElementsByClassName("ms-srch-ellipsis");
        if (searchResults != lastresults) {
            window.clearInterval(cancelwaitforsearchinterval);
            var searchInput = '';
		if (document.getElementById("SearchBox") != null)
			searchInput = document.getElementById("SearchBox").getElementsByTagName("input")[0]
		__aeLogger.trace("Found Search Results..." + searchResults.length, "sp2013");

		__SP2013Agent.searchcallback(searchInput, searchResults);
        } else {
            __aeLogger.trace("waiting for new search results...", "sp2013");
        }
}

var calls = 0;

function captureSearch() {
	if (!isSearchPage() && calls < 3)
	{
		calls++;
		setTimeout(captureSearch, 1000);
		return;
	}

	if (!isSearchPage() && calls >= 3)
		return;

	__Page.readyState = "pending";
	// handlesearchevent(document.getElementById("SearchBox").getElementsByTagName("input")[0], getElementsByClassName("ms-srch-item"));

	// Bind dynamic collection function to the search button
	bindevent(getElementsByClassName("ms-srch-sb-searchLink")[0], "click", handlePaging);
	// Bind keyword input listener
	bindevent(getElementsByClassName("ms-textLarge ms-srch-sbLarge-fullWidth")[0], "keypress", handlesearchinput);

	waitForSearchResults();
	waitForSearch();
}

function __SP2013CreateAOM() {
    __aeLogger.trace("SP2013");
    __eTypes = { Page: 0, Search: 0 };
    __eEvents = {
        Visit: { id: 0, name: "Visit" },
        Leave: { id: 1, name: "Leave" },
        Search: { id: 2, name: "Search" },
        SearchResultItem: { id: 4, name: "SearchResultItem" },
        SearchResultClick: { id: 5, name: "SearchResultClick" },
        External: { id: 10, name: "External" },
        Goal: { id: 20, name: "Goal" },
        "Goal-Test": { id: 21, name: "Goal-Test" },
        Test: { id: 22, name: "Test" },
        Score: { id: 23, name: "Score" },
        Ping: { id: 24, name: "Ping" },
        Unknown: { id: -1, name: "Unknown" },
        Preview: { id: 3, name: "Preview" }
    };
    this.url = this.document.location.href;

    var that = this;
    var handlesearchevent = function (searchInput, searchResults) {
    	that.Search.readyState = "ready";
    	that.entityType = __eTypes.Search;
    	that.eventType = __eEvents.Search;
    	that.fireEvent("onsearch");
        if (searchInput) {
            // find search term
            var searchTermFromAdvanced = __Page.CookieHandler.Read("LastSearchTermFromAdvanced");
			that.Search.Keyword = (searchInput.value.replace(/ /g) == "") ? searchTermFromAdvanced : encodeURIComponent(searchInput.value);
			that.Search.Input = searchInput;
            // find out number of results
            var numberofresults = document.getElementById("ResultCount");
            if (numberofresults) {
				that.Search.NumberOfTotalResults = numberofresults.innerHTML.replace(/[^0-9]/g, "");
				if (isNaN(that.Search.NumberOfTotalResults)) that.Search.NumberOfTotalResults = -1;
            } else {
				that.Search.NumberOfTotalResults = 0;
            }
			__aeLogger.trace("total number of results:" + that.Search.NumberOfTotalResults, "sp2013");

			that.Search.EntityId = "N/A";

            var currentpage = document.getElementById("PagingSelf") ? parseInt(document.getElementById("PagingSelf").getElementsByTagName("a")[0].innerHTML, 10) : 1;

			if (typeof getElementsByClassName("ms-srch-Paging")[0] == "undefined")
			{
                // there is no paging
				that.Search.FirstResultOnPage = 1;
            }
			else
			{
				if (typeof document.getElementById("PageLinkNext") != "undefined") {
					// First page and middle page share the same formula (resultsOnPage * (numberOfPage-1) + 1)
					that.Search.FirstResultOnPage = searchResults.length * (currentpage - 1) + 1;
				}
				else {
					// The last page is tricky?
					// on the last page. check how many results there were, subtract number of results on the page, divide it by current page - 1
					that.Search.FirstResultOnPage = parseInt(that.Search.NumberOfTotalResults) - searchResults.length + 1;
				}
			}

			__aeLogger.trace("first result on this page is " + that.Search.FirstResultOnPage, "sp2013");

			that.Search.Results = [];
            for (var i = 0; i < searchResults.length; i++) {
                var currA = searchResults[i].getElementsByTagName("a")[0];
                if (currA) currA.__type = __eEvents.SearchResultItem;
				that.Search.Results.push(currA);
            }

			that.fireEvent("onsearchresults");
			__EventHandler.searchResultPageHandler();
			__Page.sendEvent(__SP2013NewVisit(), false, false);

            return;

        } else {
            throw { description: "could not find search input" };
        }
    }

    __SP2013Agent.searchcallback = handlesearchevent;

    this.eventType = __eEvents.Visit;

    captureSearch();

    if (document.location.href.match(/start\.aspx/) && document.location.hash.match(/#\//)) __Page.readyState = "pending";

    if (__Page.eventType != null && __Page.eventType.id == 2) {
	    this.eventType = __eEvents.Preview;
	} else {
	    this.eventType = __eEvents.Visit;
	}

	this.fireEvent("onvisit");
	// check type of page
	this.entityType = __eTypes.Page;

	this.fireEvent("onload");
}

function __SP2013CreateCustom() {
    // check if advanced, add keyword to cookie
    var isAdvanced = false;
    for (var i = 0; i < AdvancedSearchPages.length; i++) {
        var re = new RegExp(AdvancedSearchPages[i], "i");
        if (document.location.href.match(re)) {
            isAdvanced = true;
            __captureSearchTerm();
        }
    }
    if (!isAdvanced) {
        __Page.CookieHandler.Delete("LastSearchTermFromAdvanced");
    }
}

function __captureSearchTerm() {
    var inputs = document.getElementsByTagName("input");
    for (var i = 0; i < inputs.length; i++) {
        if (inputs[i].type == "submit") {
            if (inputs[i].attachEvent) {
                inputs[i].attachEvent("onclick", function () {
                    for (var i = 0; i < inputs.length; i++) {
                        if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                            __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value);
                            break;
                        }
                    }
                });
            } else {
                try {
                    inputs[i].addEventListener("click", function () {
                        for (var i = 0; i < inputs.length; i++) {
                            if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                                __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value);
                                break;
                            }
                        }
                    }, false);
                } catch (e) {
                }
            }
        }
    }
}
__initEnvironmentAgent();

// RIBBON BUG FIX (for SharePoint 2013 on Chrome only)
if (typeof _spBodyOnLoadWrapper !== 'undefined') {
    if (typeof _spBodyOnLoadCalled === 'undefined' || _spBodyOnLoadCalled == false) {
        _spBodyOnLoadWrapper();
    }
}


function normalizeSPUserAccount(userName) {
	if (userName == null)
		return "";
    var splitedTokens = userName.split("|");
    return splitedTokens[splitedTokens.length - 1].replace("&nbsp;", "");
}

//this function is used to retrieve user account for sharepoint online
function getSPUserAccount(callback) {
    if (typeof (_spPageContextInfo) != "undefined" && typeof (_spPageContextInfo.userId) == "undefined") {
        callback(null);
        return;
    }

    getSPUserAccountInternal(callback, 1);
}

function getSPUserAccountInternal(callback, iter) {
    if (typeof (SP.ClientContext) == "undefined") {
        if (iter < 2) {
            window.setTimeout(function () {
                getSPUserAccountInternal(callback, (iter + 1));
            }, 50);
        }
        else {
            getSPUserAccountFromUserDisp(callback);
        }
        return;
    }


    try {
		var ctx = SP.ClientContext.get_current();
		var usr = ctx.get_web().get_currentUser();
		ctx.load(usr);
		ctx.executeQueryAsync(Function.createDelegate(this, function () {
			//get_loginName
			var userName = null;
			userName = normalizeSPUserAccount(usr.get_loginName());

			callback(userName);
		}));
	}
	catch (ex) {
		__aeLogger.trace("Error when trying to access SP object. function getSPUserAccountInternal.");
		getSPUserAccountFromUserDisp(callback);
	}


    return;
}


//this function is used to retrieve user account for sharepoint online
function getSPUserAccountFromUserDisp(callback) {
    var url = window.location.protocol + "//" + window.location.host;

    if (typeof L_Menu_BaseUrl !== "undefined" && L_Menu_BaseUrl) { //2007
        url += L_Menu_BaseUrl == "" ? "/" : L_Menu_BaseUrl;
    }

    url += "/_layouts/userdisp.aspx?Force=True&d=" + new Date().getTime();

    var xmlhttp;
    if (window.XMLHttpRequest) { // code for IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp = new XMLHttpRequest();
    } else { // code for IE6, IE5
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }

    xmlhttp.onreadystatechange = function () {
        if (xmlhttp.readyState == 4 && xmlhttp.statusText == "OK") {
            var _current_user_name;
            try {
                var resHtml = xmlhttp.responseText.toLowerCase();

                var strToSearch = '<td valign="top" class="ms-formbody" width="350px" id="spfieldtext">';
                var pos = resHtml.indexOf(strToSearch);
                if (pos >= 0) {
                    var dispnamePropertiesHtml = resHtml.substring(resHtml.indexOf(strToSearch) + strToSearch.length, resHtml.length);
                    dispnamePropertiesHtml = dispnamePropertiesHtml.substring(0, dispnamePropertiesHtml.indexOf('</td>') - 5);
                    dispnamePropertiesHtml = dispnamePropertiesHtml.substring(dispnamePropertiesHtml.indexOf('-->') + 3, dispnamePropertiesHtml.length);
                    _current_user_name = normalizeSPUserAccount(dispnamePropertiesHtml.replace(/^\s+|\s+$/gm, ''));
                }
            } catch (ex) {
                __aeLogger.trace(ex.message);
            }

            if (!_current_user_name) {
                _current_user_name = "Anonymous_" + Math.random() * 100000;
            }

            callback(_current_user_name);
        }
    }

    xmlhttp.open("GET", url, true);
    xmlhttp.send();
}